<?php
/**
 * WPPA Upload block
 * Generates a block with the shortcode for an upload box
 *
 * Version 8.2.02.004
 */

defined( 'ABSPATH' ) || exit;

/**
 * Registers all block assets so that they can be enqueued through Gutenberg in
 * the corresponding context.
 */
function wp_photo_album_plus_upload_register_block() {
global $wppa_domain_loaded;

	if ( ! function_exists( 'register_block_type' ) ) {

		// Gutenberg is not active.
		return;
	}

	// Create required js data
	add_action( 'admin_footer', 'wppa_upload_block_js', 1 );

	register_block_type( __DIR__ );

	if ( function_exists( 'wp_set_script_translations' ) && ! $wppa_domain_loaded ) {

		wp_set_script_translations( 'wppa-text-domain', 'wp-photo-album-plus' );
		$wppa_domain_loaded = true;
	}

}
add_action( 'init', 'wp_photo_album_plus_upload_register_block' );

// Make the albumlist in js
function wppa_upload_block_js() {
global $wpdb;
static $been_here;
global $wppa_albumlist_created;

	if ( $been_here ) return;

	if ( $wppa_albumlist_created ) return;

	// Get all album names and ids
	$albums = $wpdb->get_results( 	"SELECT id, name
									FROM $wpdb->wppa_albums",
									ARRAY_A
								);

	// Add paths
	$albums = wppa_add_paths( $albums );

	// Sort
	$albums = wppa_array_sort( $albums, 'name' );

	// Now make the list
	$the_js = '
	var wppaAlbumList = ["dummy",';
	foreach( $albums as $album ) {
		$the_js .= '
		{ label: "' . str_replace( '&gt;', '>', addslashes( $album['name'] ) ) . '", value: "' . $album['id'] . '" },';
	}
	$the_js .= ']';

	wppa_add_inline_script( 'wppa-admin', $the_js, true );

	$been_here = true;

	$wppa_albumlist_created = true;

}
